<template>
  <div class="block w-full home h-fit">
    <banner :banners-data="banners" />
    <div class="px-8"><game-type-button /></div>
    <games-section-button :index-blog="indexBlog" />
    <div class="game-list-container">
      <div
        v-if="topGames.length > 0 && !topGameEnabled.IsHidden"
        class="px-8 pb-20"
      >
        <div class="section__header">
          <h2 class="section__title">{{ topGameEnabled.Text }}</h2>
        </div>
        <div class="grid games__list">
          <game-entry
            v-for="(game, index) in topGames.slice(0, 23)"
            :key="index"
            :game-data="game"
            :tab-type="'games'"
            :check-is-favourite="checkIsFavourite"
            :set-and-unset-game-to-favourite="setAndUnsetGameToFavourite"
            :redirect-to-login="redirectToLogin"
          />
        </div>
      </div>
      <div
        v-if="newGames.length > 0 && !newGameEnabled.IsHidden"
        class="px-8 pb-20"
      >
        <div class="section__header">
          <h2 class="section__title">{{ newGameEnabled.Text }}</h2>
        </div>
        <div class="grid games__list">
          <game-entry
            v-for="(game, index) in newGames.slice(0, 23)"
            :key="index"
            :game-data="game"
            tab-type="games"
            :check-is-favourite="checkIsFavourite"
            :set-and-unset-game-to-favourite="setAndUnsetGameToFavourite"
            :redirect-to-login="redirectToLogin"
          />
        </div>
      </div>
    </div>
    <welcome />
    <join-now-card />
  </div>
</template>
<script lang="ts" setup>
import Banner from "./components/Banner.client.vue";
import Welcome from "./components/Welcome.client.vue";
import GameTypeButton from "./components/GameTypeButton.client.vue";
import GamesSectionButton from "./components/GamesSectionButton.client.vue";
import JoinNowCard from "./components/JoinNowCard.client.vue";
import GameEntry from "./components/gameComponents/GameEntry.client.vue";
import { GameBsi } from "@/models/bsiGameList";
import { IThemePropertiesFromApi } from "@/models/companyThemePropertiesRespone";
import themePropertyHelper from "@/utils/themePropertyHelper";
import { store } from "~~/store";
import { gameStore } from "~~/store/game";

const themeProperties = computed(
  () => store.state.companyThemePropertiesFromApi.ThemeProperties
);
const games = computed(() =>
  gameStore.state.games.map((item) => new GameBsi(item))
);
const topGameEnabled = computed(
  (): IThemePropertiesFromApi =>
    themePropertyHelper.getSingleThemeProperty(
      themeProperties.value,
      "index_blog_1"
    )
);
const newGameEnabled = computed(
  (): IThemePropertiesFromApi =>
    themePropertyHelper.getSingleThemeProperty(
      themeProperties.value,
      "index_blog_2"
    )
);
const banners = computed(
  (): Array<IThemePropertiesFromApi> =>
    themePropertyHelper.getMultipleThemesProperties(
      themeProperties.value,
      "lobby_banner_"
    )
);
const topGames = computed(() =>
  games.value.filter((isTopGame) => isTopGame.IsHotGame)
);
const newGames = computed(() =>
  games.value.filter((isNewGame) => isNewGame.IsNewGame)
);
const {
  setAndUnsetGameToFavourite,
  checkIsFavourite,
  redirectToLogin,
} = useAddToFavorite();
</script>
<style lang="scss" scoped>
.games__list {
  grid-template-columns: repeat(8, 1fr);
}
.section__header {
  position: relative;
  display: -webkit-box;
  display: -ms-flexbox;
  display: flex;
  -webkit-box-pack: justify;
  -ms-flex-pack: justify;
  justify-content: space-between;
  -webkit-box-align: center;
  -ms-flex-align: center;
  align-items: center;
  width: 100%;
  margin-bottom: 40px;
}
.section__title {
  display: -webkit-box;
  display: -ms-flexbox;
  display: flex;
  -webkit-box-align: center;
  -ms-flex-align: center;
  align-items: center;
  width: auto;
  margin-bottom: 0;
  font-size: 44px;
  -webkit-transition: color 0.4s;
  transition: color 0.4s;
  color: var(--title-font-color);
  line-height: 52px;
  padding-right: 50px;
  text-transform: uppercase;
  @media (max-width: 767px) {
    font-size: 36px;
    line-height: 46px;
    padding-right: 0;
  }
}
</style>
